<?php

error_reporting(E_ALL & ~E_NOTICE);

//----ライブラリ読込み---------------

require('./lib/conf_common.php');
require('./lib/common2.php');
require('./lib/passwd.php');

$commonpl='./lib/conf_common.php';
$setpl='./lib/admin/set.php';
$roompl='./lib/admin/room.php';

//-----変数----------------------------

$pagetitle='チャット管理';
$maxsize=3000000;
$cookie_name="fchatcookie";
$cookie_hozon=365;

$f_size="10pt";
$l_color="#0000ff";
$b_color="#ffffff";
$t_color="#000000";


#----------------------------------

$o_main=new Main;

list($fo,$ORDER)=$o_main->ParseInt();

if($fo['mode']){
	$o_main->checkpass($fo['pass']);
}

list($lib,$mode)=explode('_',$fo['mode']);

switch($lib){
	case "room":
		if(!file_exists($roompl)){
			$o_main->Error("roomplがありません。");
		}
		include_once($roompl);
		$o_room=new Room();
		switch($mode){
			case "del":
				$o_room->Del($fo);
				break;
			case "regist":
				$o_room->Regist($fo);
				break;
			case "edit":
				$o_room->Edit($fo);
				break;
			case "editregist":
				$o_room->EditRegist($fo);
				break;
			case "position":
				$o_room->Position($fo,$ORDER);
				break;
			default:
				$o_room->RoomTop($fo);
				break;
		}

	case "set":
		if(!file_exists($setpl)){
			$o_main->Error("setplがありません。");
		}
		include_once($setpl);
		$o_set=new Set();
		switch($mode){
			case "common":
				$o_set->Common($fo);
				break;
			case "commonregist":
				$o_set->CommonRegist($fo);
				break;
			default:
				$o_set->Common($fo);
				break;
		}

	case "atop":
		$o_main->Atop($fo);
		break;
	case "menu":
		if($fo['menu'] == 'ルームの登録・編集'){
			if(!file_exists($roompl)){
				$o_main->Error("roomplがありません。");
			}
			include_once($roompl);
			$o_room=new Room();
			$o_room->RoomTop($fo);
		}
		else if($fo['menu'] == '環境設定'){
			if(!file_exists($setpl)){
				$o_main->Error("setplがありません。");
			}
			include_once($setpl);
			$o_set=new Set();
			$o_set->Common($fo,"");
		}
		else{
			$o_main->Error("modeがありません。");
		}
		break;
	default:
		$o_main->ent($fo);
		break;
}


Class Main{

function setcookie($pass){
global $cookie_name;
global $cookie_hozon;

$cook="pass:".$pass;
setcookie($cookie_name,$cook,time()+$cookie_hozon*24*3600);
}

function delcookie(){
global $cookie_name;
setcookie($cookie_name,'');
}


function ent($fo){

if($_COOKIE['pass']){
	$ck=" checked";
	$ok="1";
}

self::Head("");

print <<<EOM
<body>
<div align=center>
<br>
<br>
<br>
<table width="250" border="0" cellspacing="2" cellpadding="0">
<tr> 
<td align=center class="obi"><b><font color="#ffffff">管理用</font></b></td>
</tr>
</table>
<br>
<table width="250" cellpadding="4" class="settbl">
<tr>
<td align=center>
<form action="$ascript" method="POST">
<input type="hidden" name="mode" value="atop">
<input type="hidden" name="ok" value="$ok">
※管理用パスワードを入力してください。<br><br><br>
<input type="password" name="pass" maxlength="8" size="8" value="{$_COOKIE['pass']}"> <input type="submit" value="ログイン">
<br>
<br>
<input type="checkbox" name="cookie" value="1"$ck>クッキー
</form>
</td>
</tr>
</table>
</div>
</body>
</html>
EOM;
exit;
}

function encode($pass){
$saltset=array('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z',
'A','B','D','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
'1','2','3','4','5','6','7','8','9','0');
$count=count($saltset)-1;
srand();
$salt=$saltset[rand(0,$count)].$saltset[rand(0,$count)];
$newcode=@crypt($pass,$salt);
if(preg_match("/^\$1\$/",$newcode)){
	$newcode=@crypt($pass,'$1$');
}
return $newcode;
}

function MatchPass($pass,$coded){
$passflag=0;
if(preg_match("/^\$1\$/",$coded)){
	if(crypt($pass,'$1$') == $coded){
		$passflag=1;
	}
}
else{
	$salt=substr($coded,0,2);
	if(crypt($pass,$salt) == $coded){
		$passflag=1;
	}
}
return $passflag;
}


function checkpass($fopass){
global $passwd;

if($passwd == ""){
	self::Error("パスワードが設定されていません。");
}

if($passwd == 'admin'){
	if($fopass != $passwd){
		self::Error("パスワードが違います。");
	}
}
else{
	$passflag=self::MatchPass($fopass,$passwd);
	if(!$passflag){
		self::Error("パスワードが違います。");
	}
}
return;
}

function Atop($fo){
global $mscript;
global $review;
global $ascript;



if(!$fo['ok'] && $fo['cookie']){
	self::setcookie($fo['pass']);
}
else if($fo['ok'] && !$fo['cookie']){
	Main::delcookie();
}


Main::Head("");

print <<<EOM
<body>
<div align="center">
<table width="450" border="0" cellspacing="0" cellpadding="0">
<tr> 
<td align="right"><a href="javascript:void(0)" onclick="openwin2('$index',1000,750);" class="navi">サイト</a></td>
</tr>
</table>
<table width="450" border="0" cellspacing="2" cellpadding="0">
<tr> 
<td align=center class="obi"><b><font color="#ffffff">機能の選択</font></b></td>
</tr>
</table>
機能を選んでボタンを押してください。
<br><br>
<form action="$ascript" method="POST" style="margin:0px">
<input type="hidden" name="pass" value="{$fo['pass']}">
<input type="hidden" name="mode" value="menu">

<table cellpadding=4 width=450 class="settbl">
<tr>
<td height="40" align="center"><input type=submit name="menu" value="ルームの登録・編集" style="width:150px"></td><td>ルームの追加と削除と編集を行います。</td>
</tr>
<tr>
<td height="40" align="center"><input type=submit name="menu" value="環境設定" style="width:150px"></td><td>チャットに関する設定を行います。</td>
</tr>
</table>

</form>
</div>

</body>
</html>
EOM;
exit;

}




function Head($a){
global $t_color;
global $b_color;
global $l_color;
global $f_size;
global $ascript;
global $pagetitle;


print <<<EOM
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="Content-Style-Type" content="text/css">
<meta http-equiv="Pragma" content="no-cache">
<meta http-equiv="expires" content="0">
<META NAME="ROBOTS" CONTENT="NOINDEX,NOFOLLOW,NOARCHIVE">
<title>$pagetitle</title>
<style type="text/css">
<!--
body{
color:${t_color};
background-color:${b_color}
}
p,td,div{
font-size:${f_size};
}
a{
color : ${l_color}
}

.settbl{ 
background-color:#FFF8F4;
border:1px solid #D0B195;
border-collapse:collapse;
}
.settbl td{ 
border:1px solid #D0B195;
border-collapse:collapse;
}

.rtb{
background-color:#FFF8F4;
border:1px solid #D0B195;
border-collapse:collapse;
}
.rtb td{ 
border:1px solid #D0B195;
border-collapse:collapse;
}

.komoku{
background-color:#ECDCD7;
}
.midasi{
font-weight:bold;
}
.noline{
border:none;
}
.noline td{
border:none;
}
a.navi:link{
text-decoration:none;
color:#0000ff;
}
a.navi:visited{
text-decoration:none;
color:#0000ff;
}
a.navi:active{
text-decoration:none;
color:#0000ff;
}
a.navi:hover{
position:relative;left:1px;top:1px;
color:#0000ff;
}
.obi{
background-color:#924141;
}
.haba{
width:650px
}

.ctb{ 
background-color:#FFF8F4;
border:1px solid #D0B195;
border-collapse:collapse;
}
.ctb td{ 
border:1px solid #D0B195;
border-collapse:collapse;
}

.rtb{
background-color:#FFF8F4;
border:1px solid #D0B195;
border-collapse:collapse;
}
.rtb td{ 
border:1px solid #D0B195;
border-collapse:collapse;
}

-->
</style>
<script type="text/javascript">
function openwin(win,w,h){
var features="toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes,top=0,left=0,"+"width="+w+",height="+h;
window.open(win,"s_win",features);
}

function openwin2(win,w,h){
var features="toolbar=no,location=no,directories=no,status=no,menubar=no,scrollbars=yes,resizable=yes,top=0,left=0,"+"width="+w+",height="+h;
window.open(win,"s_win",features);
}
EOM;

if($a){
print <<<EOM
function Alert(){
	alert("${a}");
}
window.onload=Alert;
EOM;
}


print <<<EOM
</script>
</head>
EOM;

}



function Error($e){
global $t_color;
global $b_color;
global $l_color;
global $f_size;
global $pagetitle;


print <<<EOM
<!DOCTYPE HTML PUBLIC "-//W3C//DTD HTML 4.0 Transitional//EN">
<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<meta http-equiv="Content-Style-Type" content="text/css">
<title>$pagetitle</title>
<style type="text/css">
<!--
body{color:${t_color};background-color:${b_color}}
p,td,div{font-size:${f_size};}
a{color : ${l_color}}
-->
</style>
<body>
<br>
<br>
<p align="center"><font color="#ff0000">ERROR</font><br><br>
EOM;

print "$e\n";

print <<<EOM
</p>
<p align="center"><a href="#" onclick="history.back()">戻る</a></p>
</body>
</html>
EOM;

exit;

}



function FileType($t,$n){
global $UPOK;
if($t == ""){
	return;
}
list($dum,$t)=explode("/",$t);

$type=array('pjpeg'=>'jpg','jpeg'=>'jpg','gif'=>'gif','pdf'=>'pdf','msword'=>'doc','vnd.ms-excel'=>'xls','x-shockwave-flash'=>'swf','avi'=>'avi');

if($t == 'octet-stream' && preg_match("/\.csv$/",$n)){
	$type[$t]='csv';
}

if(!$type[$t]){
	return;
}
$tt=$type[$t];
if(!$UPOK[$tt]){
	return;
}
return $tt;
}


function ImgDel($upfilename,$upfilename_k){

if(count($upfilename)){
	foreach($upfilename as $v){
		if($v){
			if(file_exists("$upimgdir$v")){
				unlink("$upimgdir$v") || exit;
			}
		}
	}
}
if(count($upfilename_k)){
	foreach($upfilename_k as $v){
		if($v){
			if(file_exists("$upimgdir$v")){
				unlink("$upimgdir$v") || exit;
			}
		}
	}
}

}


function ParseInt(){
global $tag;

if($_SERVER['REQUEST_METHOD'] == 'POST'){
	$ary=&$_POST;
}
else{
	$ary=&$_GET;
}

$in=array();
$ORDER=array();
foreach($ary as $name => $value){
	$value=str_replace("&","",$value);
	$value=str_replace(",","&#44;",$value);
	$value=str_replace("<","",$value);
	$value=str_replace(">","",$value);
	$value=str_replace('"',"",$value);
	$value=str_replace("'","",$value);
	if($name == "kinsigo"){
		$value=str_replace("\x0D\x0A","\n",$value);
		$value=str_replace("\x0D","\n",$value);
		$value=str_replace("\x0A","\n",$value);
	}
	else{
		$value=str_replace("\x0D\x0A","",$value);
		$value=str_replace("\x0D","",$value);
		$value=str_replace("\x0A","",$value);
	}
	if(strpos($name,'order_') !== false){
		list($d,$n)=explode("_",$name);
		$ORDER[$n]=$value;
	}
	$in[$name]=$value;

}


return array($in,$ORDER);
}





}//Class end

?>