<?php

Class Func{


function CheckTag($value){
global $kinsigo;
global $o_main;

if(!is_array($kinsigo)){
	$kinsigo=array();
}
foreach($kinsigo as $v){
	if(preg_match("/$v/",$value)){
		$o_main->Error("禁止タグが含まれています。");
	}
}
}

function GetHost(){
$ip=$_SERVER['REMOTE_ADDR'];
$host=$_SERVER['REMOTE_HOST'];

if($host == ""){
	$host=gethostbyaddr($ip);
}

if($host){
	$ho=$host;
}
else{
	$ho=$ip;
}

return $ho;
}

function Ango($data){
global $pd;

$base='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789_/';
$len=strlen($data);
$len_p=strlen($pd);

$sal=0;
for($i=0;$i<$len_p;$i++){
	$tmp_p=substr($pd,$i,1);
	$c=unpack("C",$tmp_p);
	$sal+=$c[1];
}

srand($sal);
$sal=rand(0,10000);

srand($sal);

for($i=0;$i<$len_p;$i++){
	$ran[$i]=rand(0,127);
}

$j=0;
for($i=0;$i<$len;$i++){
	$tmp=substr($data,$i,1);
	$d_a=unpack("C",$tmp);
	$d=$d_a[1];
	$tmp_p=substr($pd,$j,1);
	$d_p_a=unpack("C",$tmp_p);
	$d_p=$d_p_a[1];
	$dum=$d_p ^ $ran[$j];
	$r=$d ^ $dum;
	$r=$r % 64;
	$result.=substr($base,$r,1);
	if($j >= $len_p){
		$j=0;
	}
}

return($result);
}



function LockCheck($room){
global $logdir;
global $lbuf;
global $o_main;

$file=$logdir.$room.'_rlock';

if(!file_exists($file)){
	return false;
}

$fp=@fopen($file,"r");
if(!$fp){
	$o_main->Error("${file}が開けません。");
}
$ln=fgets($fp,$lbuf);
fclose($fp);


return $ln;
}

function CheckTimeIni($room,$num,$no){
global $timer_taiki;
global $timer_fukusu;
global $timer_mugon;
global $o_chat;

if(($no == 1) && ($num == 1)){
	$limit=$timer_taiki;
}
else{
	$limit=$timer_fukusu;
}

list($start_time,$regist_time)=self::GetTime($room,$no);

$now=time();

$ato=$timer_mugon - ($now - $regist_time);
$riyou=$limit - ($now - $start_time);

$flag=false;
if(($now - $start_time) >= $limit){
	$flag=true;
}
else if(($now - $regist_time) >= $timer_mugon){
	$flag=true;
}

if($flag){
	self::FileClear($room);
	$o_chat->ImageAllDel($room);
}

return;
}

function FileClear($room){
global $FILES;
global $logdir;
global $o_main;

foreach($FILES as $f){
	$file=$logdir.$room.'_'.$f;
	$fp=@fopen($file,'w');
	if(!$fp){
		$o_main->Error("fileが開けません。");
	}
	fclose($fp);
}

}


function CheckTime($room,$no,$code,$num){
global $timer_taiki;
global $timer_fukusu;
global $timer_mugon;
global $o_chat;

if(($no == 1) && ($num == 1)){
	$limit=$timer_taiki;
}
else{
	$limit=$timer_fukusu;
}

list($start_time,$regist_time)=self::GetTime($room,$no);

$now=time();

$ato=$timer_mugon - ($now - $regist_time);
$riyou=$limit - ($now - $start_time);

if(($now - $start_time) >= $limit){
	$o_chat->Syuryo($room,$no,$code,"limit");
}
else if(($now - $regist_time) >= $timer_mugon){
	$o_chat->Syuryo($room,$no,$code,"notime");
}

return array($ato,$riyou);

}

function GetTime($room,$no){
global $lbuf;
global $logdir;
global $o_main;

$file=$logdir.$room.'_timer.log';

$fp=@fopen($file,'r');
if(!$fp){
	$o_main->Error("timerファイルが開けません。");
}
$flag=false;
while($ln=fgets($fp,$lbuf)){
	list($no_d)=explode(",",$ln);
	if($no_d == $no){
		$line=$ln;
		$flag=true;
		break;
	}
}
fclose($fp);

if(!$flag){
	$o_main->Error("退室させられたか、データが見つかりません。");
}

list($no,$start_time,$regist_time)=explode(",",$line);

return array($start_time,$regist_time);

}


function RenewTime($room,$no){
global $lbuf;
global $logdir;
global $o_main;

$file=$logdir.$room.'_timer.log';

$fp=@fopen($file,'r');
if(!$fp){
	$o_main->Error("timerファイルが開けません。");
}
$flag=false;
$new=array();
while($ln=fgets($fp,$lbuf)){
	list($no_d,$start_time,$regist_time)=explode(",",$ln);
	if($no_d == $no){
		$regist_time=time();
		$ln="$no_d,$start_time,$regist_time,\n";
		$flag=true;
	}
	$new[]=$ln;
}
fclose($fp);

if(!$flag){
	$o_main->Error("データが見つかりません。2");
}

$fp=@fopen($file,"w");
if(!$fp){
	$o_main->Error("${file}に書き込みできません。パーミッション等を確認してください");
}
foreach($new as $v){
	fputs($fp,$v);
}
fclose($fp);


}


function GetMemberAll($room){
global $logdir;
global $o_main;

$file=$logdir.$room.'_member.log';
$tmp=@file($file);
if(!is_array($tmp)){
	$o_main->Error("tmplogが開けません。ファイルを確認してください。2");
}

array_shift($tmp);

return $tmp;

}


function MemberCheck($room,$no,$code){
global $o_main;

$mem=self::GetMember($room,$no);
$r=self::MatchPass($mem['pass'],$code);
if(!$r){
	$o_main->Error("本人だと認証できませんでした。");
}
return;
}

function GetMember($room,$no){
global $logdir;
global $lbuf;
global $o_main;

$file=$logdir.$room.'_member.log';

$fp=@fopen($file,'r');
if(!$fp){
	$o_main->Error("memberファイルが見つかりません。");
}
$hd=fgets($fp,$lbuf);
$flag=false;
while($ln=fgets($fp,$lbuf)){
	list($no_d)=explode(",",$ln);
	if($no_d == $no){
		$line=$ln;
		$flag=true;
		break;
	}
}
fclose($fp);

if(!$flag){
	$o_main->Error("退室させられたか、無発言時間を越えたか、チャットが閉鎖になりました。");
}

$data=array();

list($data['no'],$data['name'],$data['seibetu'],$data['area'],$data['age'],$data['konreki'],$data['comment'],$data['pass'],$data['host'])=explode(",",$line);

return $data;
}


function MakePass(){
$saltset=array('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z',
'A','B','D','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
'1','2','3','4','5','6','7','8','9','0');
$count=count($saltset)-1;
srand((int)microtime()^getmypid()^time());
$salt=$saltset[rand(0,$count)].$saltset[rand(0,$count)];

$key="";
for($i=0;$i<12;$i++){
	$key.=$saltset[rand(0,$count)];
}

return($key);
}

function Encode($pass){
$saltset=array('a','b','c','d','e','f','g','h','i','j','k','l','m','n','o','p','q','r','s','t','u','v','w','x','y','z',
'A','B','D','D','E','F','G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V','W','X','Y','Z',
'1','2','3','4','5','6','7','8','9','0');
$count=count($saltset)-1;
srand((int)microtime()^getmypid()^time());
$salt=$saltset[rand(0,$count)].$saltset[rand(0,$count)];
$newcode=@crypt($pass,$salt);
if(preg_match("/^\$1\$/",$newcode)){
	$newcode=@crypt($pass,'$1$');
}
return $newcode;
}

function MatchPass($pass,$coded){
$passflag=0;
if(preg_match("/^\$1\$/",$coded)){
	if(crypt($pass,'$1$') == $coded){
		$passflag=1;
	}
}
else{
	$salt=substr($coded,0,2);
	if(crypt($pass,$salt) == $coded){
		$passflag=1;
	}
}
return $passflag;
}


function filelock($lfile){
global $o_main;

$lockflag=0;
if($flock=fopen($lfile,'w')){
	if(flock($flock,LOCK_EX)){
		$lockflag=1;
	}
	else{
		$lockflag=2;
		flock($flock,LOCK_UN);
		fclose($flock);
	}
}
else{
	$o_main->Error("lockファイルがないか、パーミッションが書き込み可になっていません。<br>","");
}
if($lockflag==2){
	$o_main->Error("書き込みできませんでした。もう一度お試しください。","");
}
return array($flock,$lockflag);
}

function unlock($lfp){
	fclose($lfp);
}



function GetRoom($room){
global $roomlog;
global $lbuf;
global $o_main;

$fp=@fopen($roomlog,'r');
if(!$fp){
	$o_main->Error("skinが開けません。");
}
$hd=fgets($fp,$lbuf);
$flag=false;
while($ln=fgets($fp,$lbuf)){
	list($no)=explode(",",$ln);
	if($no == $room){
		$line=$ln;
		$flag=true;
		break;
	}
}

if(!$flag){
	$o_main->Error("${room}のデータが見つかりません。3");
}

$data=array();
list($data['no'],$data['room_name'],$data['max'])=explode(",",$ln);

return $data;
}


}//Class End

?>
